VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "NTUsers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"Groups"
Attribute VB_Ext_KEY = "Member1" ,"Users"
Option Explicit

' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
'   Property Variables
' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
'local variable(s) to hold property value(s)
Private mvarLocalAccountName    As String 'local copy
Private mvarLocalComputerName   As String 'local copy
Private mvarDomainName          As String 'local copy
Private mvarPDC                 As String 'local copy
Private mvarGroups              As Groups
Private mvarUsers               As Users
Private mvarGroupsLoaded        As Boolean 'local copy
Private mvarUsersLoaded         As Boolean 'local copy

'To fire this event, use RaiseEvent with the following syntax:
'RaiseEvent GroupsLoadingComplete[(arg1, arg2, ... , argn)]
Public Event GroupsLoadingComplete()
'To fire this event, use RaiseEvent with the following syntax:
'RaiseEvent UsersLoadingComplete[(arg1, arg2, ... , argn)]
Public Event UsersLoadingComplete()


' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
'   Class Variables
' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
Public Enum GroupType
    NetLocalGroup = 0
    NetGroup
End Enum

Private Enum LocalGroupInfo
    LocalGroupInfo_0
    LocalGroupInfo_1
End Enum

Private Enum GroupInfo
    GroupInfo_0
    GroupInfo_1
    GroupInfo_2
End Enum

' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
'   Functions
' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long
Private Declare Function OpenProcessToken Lib "advapi32.dll" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Private Declare Function GetTokenInformation Lib "advapi32.dll" (ByVal TokenHandle As Long, ByVal TokenInformationClass As Long, ByRef TokenInformation As Byte, ByVal TokenInformationLength As Long, ReturnLength As Long) As Long
Private Declare Function LookupAccountSid Lib "advapi32.dll" Alias "LookupAccountSidA" (ByVal lpSystemName As String, ByRef SID As Byte, ByVal Name As String, ByRef cbName As Long, ByVal ReferencedDomainName As String, ByRef cbReferencedDomainName As Long, ByRef peUse As Long) As Long
Private Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function NetGetDCName Lib "netapi32.dll" (ServerName As Any, DomainName As Any, ppBuffer As Long) As Long
Private Declare Function NetGetAnyDCName Lib "netapi32.dll" (ServerName As Any, DomainName As Any, ppBuffer As Long) As Long
Private Declare Function NetApiBufferFree Lib "netapi32" (ByVal pBuffer As Long) As Long
Private Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (pTo As Any, uFrom As Any, ByVal lSize As Long)
Private Declare Function lstrlenW Lib "kernel32" (ByVal lpString As Long) As Long
Private Declare Function lstrcpyW Lib "kernel32" (lpString1 As Byte, ByVal lpString2 As Long) As Long

    
Private Declare Function NetLocalGroupEnum Lib "netapi32" (ServerName As Any, _
    ByVal Level As Long, ppBufferPointer As Long, ByVal PrefMaxLen As Long, _
    ByRef EntriesRead As Long, ByRef RetCount As Long, _
    ByRef ResumeHandle As Long) As Long
    
Private Declare Function NetGroupEnum Lib "netapi32" (ServerName As Any, _
    ByVal Level As Long, ppBufferPointer As Long, ByVal PrefMaxLen As Long, _
    ByRef EntriesRead As Long, ByRef RetCount As Long, _
    ByRef ResumeHandle As Long) As Long
    
    
Private Declare Function GetLastError Lib "kernel32" () As Long

' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
'   Types that are required
' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
Private Type SID_AND_ATTRIBUTES
    SID As Long
    Attributes As Long
End Type

Private Type TOKEN_USER
    InfoBuffer As String * 200
End Type

' type for the Local Groups
Private Type LocalGroup_Info_0
    GroupName   As Long
End Type

Private Type LocalGroup_Info_1
    GroupName   As Long
    Comment     As Long
End Type

' types for Domain Groups
Private Type Group_Info_0
    GroupName   As Long
End Type

Private Type Group_Info_1
    GroupName   As Long
    Comment     As Long
End Type

Private Type Group_Info_2
    GroupName   As Long
    Comment     As Long
    GroupId     As Long
    Attributes  As Long
End Type

' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
'   Constants that are needed
' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
Private Const READ_CONTROL               As Long = &H20000
Private Const TOKEN_QUERY                As Long = &H8
Private Const ERROR_MORE_DATA            As Long = 234
Private Const NERR_Success               As Long = 0
Private Const NERR_TRUE                  As Long = 1
Private Const RPC_S_SERVER_UNAVAILABLE   As Long = 1722
Private Const ERROR_ACCESS_DENIED        As Long = 5
Private Const ERROR_INVALID_LEVEL        As Long = 124
Private Const ERROR_INVALID_COMPUTERNAME As Long = 2351



Public Function LoadUsersOk(DomainToLoadFrom As GroupType) As Boolean

    Dim lngErr          As Long

    On Error GoTo LoadUsersOk_Error

LoadUsersOk_Exit:
    mvarUsersLoaded = True
    LoadUsersOk = True
    RaiseEvent UsersLoadingComplete
    Exit Function
    
LoadUsersOk_Error:
    mvarUsersLoaded = False
    LoadUsersOk = False
    RaiseEvent UsersLoadingComplete
    Err.Raise vbObjectError + lngErr, App.Title, LoadResString(ErrorBase + lngErr)

End Function

Public Property Get Users() As Users
    If mvarUsers Is Nothing Then
        Set mvarUsers = New Users
    End If


    Set Users = mvarUsers
End Property


Public Property Set Users(vData As Users)
    Set mvarUsers = vData
End Property


Public Property Let UsersLoaded(ByVal vData As Boolean)
Attribute UsersLoaded.VB_Description = "Returns/Sets an indicator on whether or not the users have been loaded."
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.UsersLoaded = 5
    mvarUsersLoaded = vData
End Property






Public Property Get GroupsLoaded() As Boolean
Attribute GroupsLoaded.VB_Description = "Returns/Sets an indicator on whether or not the groups have been loaded."
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.GroupsLoaded
    GroupsLoaded = mvarGroupsLoaded
End Property



Public Function LoadGroupsOk(DomainToLoadFrom As GroupType) As Boolean
Attribute LoadGroupsOk.VB_Description = "Loads the Groups collection with a list of groups for the specified PDC"

    On Error GoTo LoadGroupsOk_Error
    
    Dim lngNumber           As Long
    Dim buffArray           As Long
    Dim PDCByteArray()      As Byte
    Dim GroupInfoArray()        As Group_Info_1
    Dim LocalGroupInfoArray()   As LocalGroup_Info_1
    Dim lngTemp             As Long
    Dim lngCurrIndex        As Long
    Dim lngReturnCode       As Long
    Dim strGroup            As String
    Dim strDesc             As String
    Dim lngNextIndex        As Long     ' The next index in the group list
    Dim lngEntriesRead      As Long
    Dim lngErr              As Long

    Dim objGroup            As Group

    ' Clear the previous group collect
    For Each objGroup In mvarGroups
        mvarGroups.Remove 1
    Next objGroup
    Set objGroup = Nothing
    
    ' Convert the PDC String into a byte array
    PDCByteArray = mvarPDC & vbNullChar

    Do
        ' Determine what group list to get
        Select Case DomainToLoadFrom
            Case NetLocalGroup
                ' Get the group list from the local machine
                lngReturnCode = NetLocalGroupEnum(0, LocalGroupInfo_1, buffArray, 1024, lngEntriesRead, lngNumber, lngNextIndex)
            Case NetGroup
                ' Get the group list from the PDC
                lngReturnCode = NetGroupEnum(PDCByteArray(0), GroupInfo_1, buffArray, 1024, lngEntriesRead, lngNumber, lngNextIndex)
        End Select
        
        ' Check for an error
        If lngReturnCode <> ERROR_MORE_DATA And lngReturnCode <> NERR_Success Then
            Select Case lngReturnCode
                Case RPC_S_SERVER_UNAVAILABLE
                    lngErr = ErrServerUnavailable
                Case ERROR_ACCESS_DENIED
                    lngErr = ErrAccessDenied
                Case ERROR_INVALID_LEVEL
                    lngErr = ErrInvalidLevelUsed
                Case ERROR_INVALID_COMPUTERNAME
                    lngErr = ErrInvalidComputerName
                Case Else
                    lngErr = 0
            End Select
            ' Don't process anymore
            GoTo LoadGroupsOk_Error
        End If
        
        ' Copy the Array created from the NetQueryDisplayInformation call
        '   to a group info array
        ' See what domain we loaded from so we know what group type to load
        Select Case DomainToLoadFrom
            Case NetLocalGroup
                CopyLocalGroupInfo buffArray, lngNumber, LocalGroupInfoArray
            Case NetGroup
                CopyGroupInfo buffArray, lngNumber, GroupInfoArray
        End Select
        
        For lngTemp = 0 To lngNumber - 1
            lngCurrIndex = lngCurrIndex + 1
            
            Select Case DomainToLoadFrom
                Case NetLocalGroup
                    strGroup = PointerToUnicodeStr(LocalGroupInfoArray(lngTemp).GroupName)
                    strDesc = PointerToUnicodeStr(LocalGroupInfoArray(lngTemp).Comment)
                Case NetGroup
                    strGroup = PointerToUnicodeStr(GroupInfoArray(lngTemp).GroupName)
                    strDesc = PointerToUnicodeStr(GroupInfoArray(lngTemp).Comment)
            End Select
        
            Set objGroup = New Group
            With objGroup
                .GroupName = strGroup
                .Description = strDesc
            End With
            mvarGroups.Add objGroup.GroupName, objGroup.Description
            Set objGroup = Nothing
        Next lngTemp
        
        If buffArray Then
            Call NetApiBufferFree(buffArray)
            buffArray = 0
        End If
        
        DoEvents
    
    Loop While lngReturnCode = ERROR_MORE_DATA
    
    If buffArray Then
        Call NetApiBufferFree(buffArray)
        buffArray = 0
    End If

LoadGroupsOk_Exit:
    mvarGroupsLoaded = True
    LoadGroupsOk = True
    RaiseEvent GroupsLoadingComplete
    Exit Function
    
LoadGroupsOk_Error:
    mvarGroupsLoaded = False
    LoadGroupsOk = False
    RaiseEvent GroupsLoadingComplete
    Err.Raise vbObjectError + lngErr, App.Title, LoadResString(ErrorBase + lngErr)

End Function




Public Property Get Groups() As Groups
    If mvarGroups Is Nothing Then
        Set mvarGroups = New Groups
    End If


    Set Groups = mvarGroups
End Property


Private Sub CopyLocalGroupInfo(ppBuffer As Long, lNum As Long, Buffer() As LocalGroup_Info_1)
    
    Dim lLen As Long
    
    If (ppBuffer > 0 And lNum > 0) Then
        ReDim Buffer(0 To (lNum - 1)) As LocalGroup_Info_1
        lLen = Len(Buffer(0)) * lNum
        CopyMem Buffer(0), ByVal ppBuffer, lLen
    End If
    
End Sub
Private Sub CopyGroupInfo(ppBuffer As Long, lNum As Long, Buffer() As Group_Info_1)
    
    Dim lLen As Long
    
    If (ppBuffer > 0 And lNum > 0) Then
        ReDim Buffer(0 To (lNum - 1)) As Group_Info_1
        lLen = Len(Buffer(0)) * lNum
        CopyMem Buffer(0), ByVal ppBuffer, lLen
    End If
    
End Sub

Private Function PointerToUnicodeStr(lpUnicodeStr As Long) As String
   Dim Buffer() As Byte
   Dim nLen As Long
   
   If lpUnicodeStr Then
      nLen = lstrlenW(lpUnicodeStr) * 2
      If nLen Then
         ReDim Buffer(0 To (nLen - 1)) As Byte
         CopyMem Buffer(0), ByVal lpUnicodeStr, nLen
         PointerToUnicodeStr = Buffer
      End If
   End If

End Function



Public Property Set Groups(vData As Groups)
    Set mvarGroups = vData
End Property
Private Sub Class_Terminate()
    Set mvarUsers = Nothing
    Set mvarUsers = Nothing
    Set mvarGroups = Nothing
End Sub



Public Property Let LocalAccountName(ByVal vData As String)
Attribute LocalAccountName.VB_Description = "Returns/Sets the local users account name."
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.LocalAccountName = 5
    mvarLocalAccountName = vData
End Property


Public Property Get LocalAccountName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.LocalAccountName
    LocalAccountName = mvarLocalAccountName
End Property



Public Property Let PDC(ByVal vData As String)
Attribute PDC.VB_Description = "Returns/Sets the name of The PDC"
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.PDC = 5
    mvarPDC = vData
End Property


Public Property Get PDC() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.PDC
    PDC = mvarPDC
End Property









Public Property Let DomainName(ByVal vData As String)
Attribute DomainName.VB_Description = "Returns/Sets the name of the domain's PDC"
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.DomainName = 5
    mvarDomainName = vData
End Property


Public Property Get DomainName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.DomainName
    DomainName = mvarDomainName
End Property



Public Property Let LocalComputerName(ByVal vData As String)
Attribute LocalComputerName.VB_Description = "Returns/Sets the local host name"
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.LocalComputerName = 5
    mvarLocalComputerName = vData
End Property


Public Property Get LocalComputerName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.LocalComputerName
    LocalComputerName = mvarLocalComputerName
End Property



Private Sub Class_Initialize()

    Dim hProcess            As Long
    Dim hAccessToken        As Long
    Dim lngReturnCode       As Long
    Dim InfoBuffer(1000)    As Byte
    Dim pBuffer             As Long
    Dim UserToken           As TOKEN_USER
    Dim lLen                As Long
    Dim UserSID             As SID_AND_ATTRIBUTES
    Dim strAcctName         As String * 255
    Dim strCompName         As String * 255
    Dim strDomain           As String * 255
    
    Dim lSidUse             As Long

    Dim WStr()              As Byte
    Dim lngErr              As Long     ' The error that gets generated

    On Error GoTo Class_Initialize_Error
    
    'Get process handle
    hProcess = GetCurrentProcess()
    
    'get process token
    If (OpenProcessToken(hProcess, TOKEN_QUERY, hAccessToken) <> NERR_TRUE) Then
        lngErr = ErrFailedProcessToken
        GoTo Class_Initialize_Error
    End If
    
    'get Token information
    If (GetTokenInformation(hAccessToken, 1, InfoBuffer(0), 100, lLen) <> NERR_TRUE) Then
        lngErr = ErrFailedTokenInfo
        GoTo Class_Initialize_Error
    End If
    
    'get user account and domain using SID obtained above
    If (LookupAccountSid(vbNullString, InfoBuffer(8), strAcctName, Len(strAcctName), strDomain, Len(strDomain), lSidUse) <> NERR_TRUE) Then
        lngErr = ErrFailedSIDInfo
        GoTo Class_Initialize_Error
    End If
    
    'get local computer name
    If (GetComputerName(strCompName, Len(strCompName)) <> NERR_TRUE) Then
        lngErr = ErrFailedComputerName
        GoTo Class_Initialize_Error
    End If

    mvarLocalComputerName = Trim$(Left$(strCompName, InStr(strCompName, vbNullChar) - 1))
    mvarDomainName = Trim$(Left$(strDomain, InStr(strDomain, vbNullChar) - 1))
    mvarLocalAccountName = Trim$(Left$(strAcctName, InStr(strAcctName, vbNullChar) - 1))

    If (mvarLocalComputerName = mvarDomainName) Then
        ' The user is a local user
        lngReturnCode = NetGetAnyDCName(0, 0, pBuffer)
        mvarPDC = PointerToUnicodeStr(pBuffer)
        mvarDomainName = mvarPDC
    Else
        ' The user is a domain user
        WStr = Trim$(strDomain) & vbNullChar
        lngReturnCode = NetGetDCName(0, WStr(0), pBuffer)
        mvarPDC = PointerToUnicodeStr(pBuffer)
    End If

    If pBuffer Then Call NetApiBufferFree(pBuffer)

Class_Initialize_Exit:
    ' Initialize the Group and User collections
    Set mvarGroups = New Groups
    Set mvarUsers = New Users
    Exit Sub
    
Class_Initialize_Error:
    Err.Raise vbObjectError + lngErr, App.Title, LoadResString(ErrorBase + lngErr)
    Err.Clear
End Sub


